Index: drivers/filesystems/btrfs/create.c
===================================================================
--- drivers/filesystems/btrfs/create.c	(révision 74430)
+++ drivers/filesystems/btrfs/create.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -20,7 +20,7 @@
 #endif /* __REACTOS__ */
 #include "btrfs_drv.h"
 #ifndef __REACTOS__
-#include <winioctl.h>
+#include <ntddstor.h>
 #endif
 
 extern PDEVICE_OBJECT devobj;
@@ -27,13 +27,21 @@
 
 static WCHAR datastring[] = L"::$DATA";
 
-fcb* create_fcb(POOL_TYPE pool_type) {
+fcb* create_fcb(device_extension* Vcb, POOL_TYPE pool_type) {
     fcb* fcb;
     
-    fcb = ExAllocatePoolWithTag(PagedPool, sizeof(struct _fcb), ALLOC_TAG);
-    if (!fcb) {
-        ERR("out of memory\n");
-        return NULL;
+    if (pool_type == NonPagedPool) {
+        fcb = ExAllocatePoolWithTag(pool_type, sizeof(struct _fcb), ALLOC_TAG);
+        if (!fcb) {
+            ERR("out of memory\n");
+            return NULL;
+        }
+    } else {
+        fcb = ExAllocateFromPagedLookasideList(&Vcb->fcb_lookaside);
+        if (!fcb) {
+            ERR("out of memory\n");
+            return NULL;
+        }
     }
     
 #ifdef DEBUG_FCB_REFCOUNTS
@@ -40,14 +48,20 @@
     WARN("allocating fcb %p\n", fcb);
 #endif
     RtlZeroMemory(fcb, sizeof(struct _fcb));
+    fcb->pool_type = pool_type;
     
     fcb->Header.NodeTypeCode = BTRFS_NODE_TYPE_FCB;
     fcb->Header.NodeByteSize = sizeof(struct _fcb);
     
-    fcb->nonpaged = ExAllocatePoolWithTag(NonPagedPool, sizeof(struct _fcb_nonpaged), ALLOC_TAG);
+    fcb->nonpaged = ExAllocateFromNPagedLookasideList(&Vcb->fcb_np_lookaside);
     if (!fcb->nonpaged) {
         ERR("out of memory\n");
-        ExFreePool(fcb);
+        
+        if (pool_type == NonPagedPool)
+            ExFreePool(fcb);
+        else
+            ExFreeToPagedLookasideList(&Vcb->fcb_lookaside, fcb);
+        
         return NULL;
     }
     RtlZeroMemory(fcb->nonpaged, sizeof(struct _fcb_nonpaged));
@@ -80,10 +94,10 @@
     return fcb;
 }
 
-file_ref* create_fileref() {
+file_ref* create_fileref(device_extension* Vcb) {
     file_ref* fr;
     
-    fr = ExAllocatePoolWithTag(PagedPool, sizeof(file_ref), ALLOC_TAG);
+    fr = ExAllocateFromPagedLookasideList(&Vcb->fileref_lookaside);
     if (!fr) {
         ERR("out of memory\n");
         return NULL;
@@ -91,10 +105,10 @@
     
     RtlZeroMemory(fr, sizeof(file_ref));
     
-    fr->nonpaged = ExAllocatePoolWithTag(NonPagedPool, sizeof(file_ref_nonpaged), ALLOC_TAG);
+    fr->nonpaged = ExAllocateFromNPagedLookasideList(&Vcb->fileref_np_lookaside);
     if (!fr->nonpaged) {
         ERR("out of memory\n");
-        ExFreePool(fr);
+        ExFreeToPagedLookasideList(&Vcb->fileref_lookaside, fr);
         return NULL;
     }
     
@@ -106,18 +120,19 @@
     
     InitializeListHead(&fr->children);
     
+    ExInitializeResourceLite(&fr->nonpaged->fileref_lock);
     ExInitializeResourceLite(&fr->nonpaged->children_lock);
     
     return fr;
 }
 
-static NTSTATUS STDCALL find_file_in_dir(device_extension* Vcb, PUNICODE_STRING filename, fcb* fcb,
-                                         root** subvol, UINT64* inode, dir_child** pdc, BOOL case_sensitive, PIRP Irp) {
+static NTSTATUS STDCALL find_file_in_dir(PUNICODE_STRING filename, fcb* fcb, root** subvol, UINT64* inode, dir_child** pdc, BOOL case_sensitive) {
     NTSTATUS Status;
     UNICODE_STRING fnus;
     UINT32 hash;
     LIST_ENTRY* le;
     UINT8 c;
+    BOOL locked = FALSE;
     
     if (!case_sensitive) {
         Status = RtlUpcaseUnicodeString(&fnus, filename, TRUE);
@@ -133,7 +148,10 @@
     
     c = hash >> 24;
     
-    ExAcquireResourceSharedLite(&fcb->nonpaged->dir_children_lock, TRUE);
+    if (!ExIsResourceAcquiredSharedLite(&fcb->nonpaged->dir_children_lock)) {
+        ExAcquireResourceSharedLite(&fcb->nonpaged->dir_children_lock, TRUE);
+        locked = TRUE;
+    }
     
     if (case_sensitive) {
         if (!fcb->hash_ptrs[c]) {
@@ -234,7 +252,8 @@
     Status = STATUS_OBJECT_NAME_NOT_FOUND;
 
 end:
-    ExReleaseResourceLite(&fcb->nonpaged->dir_children_lock);
+    if (locked)
+        ExReleaseResourceLite(&fcb->nonpaged->dir_children_lock);
     
     if (!case_sensitive)
         ExFreePool(fnus.Buffer);
@@ -242,218 +261,12 @@
     return Status;
 }
 
-static BOOL find_stream(device_extension* Vcb, fcb* fcb, PUNICODE_STRING stream, PUNICODE_STRING newstreamname, UINT32* hash, PANSI_STRING xattr, PIRP Irp) {
-    NTSTATUS Status;
-    ULONG utf8len;
-    char* utf8;
-    UINT32 crc32;
-    KEY searchkey;
-    traverse_ptr tp, next_tp;
-    BOOL success = FALSE, b;
-    
-    static char xapref[] = "user.";
-    ULONG xapreflen = strlen(xapref);
-    
-    TRACE("(%p, %p, %.*S)\n", Vcb, fcb, stream->Length / sizeof(WCHAR), stream->Buffer);
-    
-    Status = RtlUnicodeToUTF8N(NULL, 0, &utf8len, stream->Buffer, stream->Length);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUnicodeToUTF8N 1 returned %08x\n", Status);
-        return FALSE;
-    }
-    
-    TRACE("utf8len = %u\n", utf8len);
-    
-    utf8 = ExAllocatePoolWithTag(PagedPool, xapreflen + utf8len + 1, ALLOC_TAG);
-    if (!utf8) {
-        ERR("out of memory\n");
-        goto end;
-    }
-    
-    RtlCopyMemory(utf8, xapref, xapreflen);
-    
-    Status = RtlUnicodeToUTF8N(&utf8[xapreflen], utf8len, &utf8len, stream->Buffer, stream->Length);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUnicodeToUTF8N 2 returned %08x\n", Status);
-        goto end;
-    }
-    
-    utf8len += xapreflen;
-    utf8[utf8len] = 0;
-    
-    TRACE("utf8 = %s\n", utf8);
-    
-    crc32 = calc_crc32c(0xfffffffe, (UINT8*)utf8, utf8len);
-    TRACE("crc32 = %08x\n", crc32);
-    
-    if ((crc32 == EA_DOSATTRIB_HASH && utf8len == strlen(EA_DOSATTRIB) && RtlCompareMemory(utf8, EA_DOSATTRIB, utf8len) == utf8len) || 
-        (crc32 == EA_EA_HASH && utf8len == strlen(EA_EA) && RtlCompareMemory(utf8, EA_EA, utf8len) == utf8len)) {
-        return FALSE;
-    }
-    
-    searchkey.obj_id = fcb->inode;
-    searchkey.obj_type = TYPE_XATTR_ITEM;
-    searchkey.offset = crc32;
-    
-    Status = find_item(Vcb, fcb->subvol, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        goto end;
-    }
-    
-    if (!keycmp(tp.item->key, searchkey)) {
-        if (tp.item->size < sizeof(DIR_ITEM)) {
-            ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
-        } else {
-            ULONG len = tp.item->size, xasize;
-            DIR_ITEM* di = (DIR_ITEM*)tp.item->data;
-            
-            TRACE("found match on hash\n");
-            
-            while (len > 0) {
-                if (len < sizeof(DIR_ITEM) || len < sizeof(DIR_ITEM) - 1 + di->m + di->n) {
-                    ERR("(%llx,%x,%llx) was truncated\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-                    break;
-                }
-                
-                if (RtlCompareMemory(di->name, utf8, utf8len) == utf8len) {
-                    TRACE("found exact match for %s\n", utf8);
-                    
-                    *hash = tp.item->key.offset;
-                    
-                    xattr->Buffer = ExAllocatePoolWithTag(PagedPool, di->n + 1, ALLOC_TAG);
-                    if (!xattr->Buffer) {
-                        ERR("out of memory\n");
-                        goto end;
-                    }
-                    
-                    xattr->Length = xattr->MaximumLength = di->n;
-                    RtlCopyMemory(xattr->Buffer, di->name, di->n);
-                    xattr->Buffer[di->n] = 0;
-                    
-                    success = TRUE;
-                    goto end;
-                }
-                
-                xasize = sizeof(DIR_ITEM) - 1 + di->m + di->n;
-                
-                if (len > xasize) {
-                    len -= xasize;
-                    di = (DIR_ITEM*)&di->name[di->m + di->n];
-                } else
-                    break;
-            }
-        }
-    }
-    
-    searchkey.offset = 0;
-    
-    Status = find_item(Vcb, fcb->subvol, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        goto end;
-    }
-    
-    do {
-        if (tp.item->key.obj_id == fcb->inode && tp.item->key.obj_type == TYPE_XATTR_ITEM && tp.item->key.offset != crc32) {
-            if (tp.item->size < sizeof(DIR_ITEM)) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
-            } else {
-                ULONG len = tp.item->size, xasize;
-                DIR_ITEM* di = (DIR_ITEM*)tp.item->data;
-                ULONG utf16len;
-                
-                TRACE("found xattr with hash %08x\n", (UINT32)tp.item->key.offset);
-                
-                while (len > 0) {
-                    if (len < sizeof(DIR_ITEM) || len < sizeof(DIR_ITEM) - 1 + di->m + di->n) {
-                        ERR("(%llx,%x,%llx) was truncated\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-                        break;
-                    }
-                    
-                    if (di->n > xapreflen && RtlCompareMemory(di->name, xapref, xapreflen) == xapreflen) {
-                        TRACE("found potential xattr %.*s\n", di->n, di->name);
-                    }
-                    
-                    Status = RtlUTF8ToUnicodeN(NULL, 0, &utf16len, &di->name[xapreflen], di->n - xapreflen);
-                    if (!NT_SUCCESS(Status)) {
-                        ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
-                    } else {
-                        WCHAR* utf16 = ExAllocatePoolWithTag(PagedPool, utf16len, ALLOC_TAG);
-                        if (!utf16) {
-                            ERR("out of memory\n");
-                            goto end;
-                        }
-                        
-                        Status = RtlUTF8ToUnicodeN(utf16, utf16len, &utf16len, &di->name[xapreflen], di->n - xapreflen);
-
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
-                        } else {
-                            UNICODE_STRING us;
-                            
-                            us.Buffer = utf16;
-                            us.Length = us.MaximumLength = (USHORT)utf16len;
-                            
-                            if (FsRtlAreNamesEqual(stream, &us, TRUE, NULL)) {
-                                TRACE("found case-insensitive match for %s\n", utf8);
-                                
-                                *newstreamname = us;
-                                *hash = tp.item->key.offset;
-                                
-                                xattr->Buffer = ExAllocatePoolWithTag(PagedPool, di->n + 1, ALLOC_TAG);
-                                if (!xattr->Buffer) {
-                                    ERR("out of memory\n");
-                                    ExFreePool(utf16);
-                                    goto end;
-                                }
-                                
-                                xattr->Length = xattr->MaximumLength = di->n;
-                                RtlCopyMemory(xattr->Buffer, di->name, di->n);
-                                xattr->Buffer[di->n] = 0;
-                                
-                                success = TRUE;
-                                goto end;
-                            }
-                        }
-                        
-                        ExFreePool(utf16);
-                    }
-                    
-                    xasize = sizeof(DIR_ITEM) - 1 + di->m + di->n;
-                    
-                    if (len > xasize) {
-                        len -= xasize;
-                        di = (DIR_ITEM*)&di->name[di->m + di->n];
-                    } else
-                        break;
-                }
-            }
-        }
-        
-        b = find_next_item(Vcb, &tp, &next_tp, FALSE, Irp);
-        if (b) {
-            tp = next_tp;
-            
-            if (next_tp.item->key.obj_id > fcb->inode || next_tp.item->key.obj_type > TYPE_XATTR_ITEM)
-                break;
-        }
-    } while (b);
-    
-end:
-    ExFreePool(utf8);
-    
-    return success;
-}
-
-static NTSTATUS split_path(PUNICODE_STRING path, UNICODE_STRING** parts, ULONG* num_parts, BOOL* stream) {
-    ULONG len, i, j, np;
+static NTSTATUS split_path(device_extension* Vcb, PUNICODE_STRING path, LIST_ENTRY* parts, BOOL* stream) {
+    ULONG len, i;
     BOOL has_stream;
-    UNICODE_STRING* ps;
     WCHAR* buf;
+    name_bit* nb;
     
-    np = 1;
-    
     len = path->Length / sizeof(WCHAR);
     if (len > 0 && (path->Buffer[len - 1] == '/' || path->Buffer[len - 1] == '\\'))
         len--;
@@ -461,7 +274,6 @@
     has_stream = FALSE;
     for (i = 0; i < len; i++) {
         if (path->Buffer[i] == '/' || path->Buffer[i] == '\\') {
-            np++;
             has_stream = FALSE;
         } else if (path->Buffer[i] == ':') {
             has_stream = TRUE;
@@ -468,34 +280,33 @@
         }
     }
     
-    if (has_stream)
-        np++;
-    
-    ps = ExAllocatePoolWithTag(PagedPool, np * sizeof(UNICODE_STRING), ALLOC_TAG);
-    if (!ps) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    RtlZeroMemory(ps, np * sizeof(UNICODE_STRING));
-    
     buf = path->Buffer;
     
-    j = 0;
     for (i = 0; i < len; i++) {
         if (path->Buffer[i] == '/' || path->Buffer[i] == '\\') {
-            ps[j].Buffer = buf;
-            ps[j].Length = (&path->Buffer[i] - buf) * sizeof(WCHAR);
-            ps[j].MaximumLength = ps[j].Length;
+            nb = ExAllocateFromPagedLookasideList(&Vcb->name_bit_lookaside);
+            if (!nb) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
             
+            nb->us.Buffer = buf;
+            nb->us.Length = nb->us.MaximumLength = (&path->Buffer[i] - buf) * sizeof(WCHAR);
+            InsertTailList(parts, &nb->list_entry);
+            
             buf = &path->Buffer[i+1];
-            j++;
         }
     }
+
+    nb = ExAllocateFromPagedLookasideList(&Vcb->name_bit_lookaside);
+    if (!nb) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
     
-    ps[j].Buffer = buf;
-    ps[j].Length = (&path->Buffer[i] - buf) * sizeof(WCHAR);
-    ps[j].MaximumLength = ps[j].Length;
+    nb->us.Buffer = buf;
+    nb->us.Length = nb->us.MaximumLength = (&path->Buffer[i] - buf) * sizeof(WCHAR);
+    InsertTailList(parts, &nb->list_entry);
     
     if (has_stream) {
         static WCHAR datasuf[] = {':','$','D','A','T','A',0};
@@ -504,16 +315,25 @@
         dsus.Buffer = datasuf;
         dsus.Length = dsus.MaximumLength = wcslen(datasuf) * sizeof(WCHAR);
         
-        for (i = 0; i < ps[j].Length / sizeof(WCHAR); i++) {
-            if (ps[j].Buffer[i] == ':') {
-                ps[j+1].Buffer = &ps[j].Buffer[i+1];
-                ps[j+1].Length = ps[j].Length - (i * sizeof(WCHAR)) - sizeof(WCHAR);
+        for (i = 0; i < nb->us.Length / sizeof(WCHAR); i++) {
+            if (nb->us.Buffer[i] == ':') {
+                name_bit* nb2;
                 
-                ps[j].Length = i * sizeof(WCHAR);
-                ps[j].MaximumLength = ps[j].Length;
+                nb2 = ExAllocateFromPagedLookasideList(&Vcb->name_bit_lookaside);
+                if (!nb2) {
+                    ERR("out of memory\n");
+                    return STATUS_INSUFFICIENT_RESOURCES;
+                }
                 
-                j++;
+                nb2->us.Buffer = &nb->us.Buffer[i+1];
+                nb2->us.Length = nb2->us.MaximumLength = nb->us.Length - (i * sizeof(WCHAR)) - sizeof(WCHAR);
+                InsertTailList(parts, &nb2->list_entry);
                 
+                nb->us.Length = i * sizeof(WCHAR);
+                nb->us.MaximumLength = nb->us.Length;
+                
+                nb = nb2;
+                
                 break;
             }
         }
@@ -520,11 +340,13 @@
         
         // FIXME - should comparison be case-insensitive?
         // remove :$DATA suffix
-        if (ps[j].Length >= dsus.Length && RtlCompareMemory(&ps[j].Buffer[(ps[j].Length - dsus.Length)/sizeof(WCHAR)], dsus.Buffer, dsus.Length) == dsus.Length)
-            ps[j].Length -= dsus.Length;
+        if (nb->us.Length >= dsus.Length && RtlCompareMemory(&nb->us.Buffer[(nb->us.Length - dsus.Length)/sizeof(WCHAR)], dsus.Buffer, dsus.Length) == dsus.Length)
+            nb->us.Length -= dsus.Length;
         
-        if (ps[j].Length == 0) {
-            np--;
+        if (nb->us.Length == 0) {
+            RemoveTailList(parts);
+            ExFreeToPagedLookasideList(&Vcb->name_bit_lookaside, nb);
+            
             has_stream = FALSE;
         }
     }
@@ -531,16 +353,11 @@
     
     // if path is just stream name, remove first empty item
     if (has_stream && path->Length >= sizeof(WCHAR) && path->Buffer[0] == ':') {
-        ps[0] = ps[1];
-        np--;
+        name_bit *nb1 = CONTAINING_RECORD(RemoveHeadList(parts), name_bit, list_entry);
+        
+        ExFreeToPagedLookasideList(&Vcb->name_bit_lookaside, nb1);
     }
 
-//     for (i = 0; i < np; i++) {
-//         ERR("part %u: %u, (%.*S)\n", i, ps[i].Length, ps[i].Length / sizeof(WCHAR), ps[i].Buffer);
-//     }
-    
-    *num_parts = np;
-    *parts = ps;
     *stream = has_stream;
     
     return STATUS_SUCCESS;
@@ -558,80 +375,6 @@
 // }
 // #endif
 
-static file_ref* search_fileref_children(file_ref* dir, PUNICODE_STRING name, BOOL case_sensitive) {
-    LIST_ENTRY* le;
-    file_ref *c, *deleted = NULL;
-    NTSTATUS Status;
-    UNICODE_STRING ucus;
-#ifdef DEBUG_FCB_REFCOUNTS
-    ULONG rc;
-#endif
-    
-    if (case_sensitive) {
-        le = dir->children.Flink;
-        while (le != &dir->children) {
-            c = CONTAINING_RECORD(le, file_ref, list_entry);
-            
-            if (c->refcount > 0 && c->filepart.Length == name->Length &&
-                RtlCompareMemory(c->filepart.Buffer, name->Buffer, name->Length) == name->Length) {
-                if (c->deleted) {
-                    deleted = c;
-                } else {
-#ifdef DEBUG_FCB_REFCOUNTS
-                    rc = InterlockedIncrement(&c->refcount);
-                    WARN("fileref %p: refcount now %i (%S)\n", c, rc, file_desc_fileref(c));
-#else
-                    InterlockedIncrement(&c->refcount);
-#endif
-                    return c;
-                }
-            }
-            
-            le = le->Flink;
-        }
-        
-        goto end;
-    }
-
-    Status = RtlUpcaseUnicodeString(&ucus, name, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        return NULL;
-    }
-        
-    le = dir->children.Flink;
-    while (le != &dir->children) {
-        c = CONTAINING_RECORD(le, file_ref, list_entry);
-        
-        if (c->refcount > 0 && c->filepart_uc.Length == ucus.Length &&
-            RtlCompareMemory(c->filepart_uc.Buffer, ucus.Buffer, ucus.Length) == ucus.Length) {
-            if (c->deleted) {
-                deleted = c;
-            } else {
-#ifdef DEBUG_FCB_REFCOUNTS
-                rc = InterlockedIncrement(&c->refcount);
-                WARN("fileref %p: refcount now %i (%S)\n", c, rc, file_desc_fileref(c));
-#else
-                InterlockedIncrement(&c->refcount);
-#endif
-                ExFreePool(ucus.Buffer);
-                
-                return c;
-            }
-        }
-        
-        le = le->Flink;
-    }
-    
-    ExFreePool(ucus.Buffer);
-    
-end:
-    if (deleted)
-        increase_fileref_refcount(deleted);
-    
-    return deleted;
-}
-
 NTSTATUS load_csum(device_extension* Vcb, UINT32* csum, UINT64 start, UINT64 length, PIRP Irp) {
     NTSTATUS Status;
     KEY searchkey;
@@ -690,6 +433,7 @@
     KEY searchkey;
     traverse_ptr tp, next_tp;
     NTSTATUS Status;
+    ULONG num_children = 0;
     
     fcb->hash_ptrs = ExAllocatePoolWithTag(PagedPool, sizeof(LIST_ENTRY*) * 256, ALLOC_TAG);
     if (!fcb->hash_ptrs) {
@@ -803,6 +547,8 @@
         
         insert_dir_child_into_hash_lists(fcb, dc);
         
+        num_children++;
+        
 cont:
         if (find_next_item(fcb->Vcb, &tp, &next_tp, FALSE, Irp))
             tp = next_tp;
@@ -810,6 +556,11 @@
             break;
     }
     
+    // If a directory has a lot of files, force it to stick around until the next flush
+    // so we aren't constantly re-reading.
+    if (num_children >= 100)
+        mark_fcb_dirty(fcb);
+    
     return STATUS_SUCCESS;
 }
 
@@ -850,7 +601,7 @@
         }
     }
     
-    fcb = create_fcb(pooltype);
+    fcb = create_fcb(Vcb, pooltype);
     if (!fcb) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
@@ -883,17 +634,17 @@
         RtlCopyMemory(&fcb->inode_item, tp.item->data, min(sizeof(INODE_ITEM), tp.item->size));
     
     if (fcb->type == 0) { // guess the type from the inode mode, if the caller doesn't know already
-        if (fcb->inode_item.st_mode & __S_IFDIR)
+        if ((fcb->inode_item.st_mode & __S_IFDIR) == __S_IFDIR)
             fcb->type = BTRFS_TYPE_DIRECTORY;
-        else if (fcb->inode_item.st_mode & __S_IFCHR)
+        else if ((fcb->inode_item.st_mode & __S_IFCHR) == __S_IFCHR)
             fcb->type = BTRFS_TYPE_CHARDEV;
-        else if (fcb->inode_item.st_mode & __S_IFBLK)
+        else if ((fcb->inode_item.st_mode & __S_IFBLK) == __S_IFBLK)
             fcb->type = BTRFS_TYPE_BLOCKDEV;
-        else if (fcb->inode_item.st_mode & __S_IFIFO)
+        else if ((fcb->inode_item.st_mode & __S_IFIFO) == __S_IFIFO)
             fcb->type = BTRFS_TYPE_FIFO;
-        else if (fcb->inode_item.st_mode & __S_IFLNK)
+        else if ((fcb->inode_item.st_mode & __S_IFLNK) == __S_IFLNK)
             fcb->type = BTRFS_TYPE_SYMLINK;
-        else if (fcb->inode_item.st_mode & __S_IFSOCK)
+        else if ((fcb->inode_item.st_mode & __S_IFSOCK) == __S_IFSOCK)
             fcb->type = BTRFS_TYPE_SOCKET;
         else
             fcb->type = BTRFS_TYPE_FILE;
